(*
 * Kinds
 *)

type kind =
  TYPE
| ARROW of kind list * kind

let domOf = function
  TYPE -> Error.bug "Syntax.domOf: Tried to find domain of kind Type"
| ARROW(kl,_) -> kl

let rec print = function
  TYPE -> Format.print_string "Type"
| ARROW(l,k) ->
  Misc.formatList "(" " -> " " " print l; print k; Format.print_string ")"
      
let rec toString = function
    TYPE -> "Type"
  | ARROW(l,k) -> 
      (Misc.listToString "(" " -> " " " toString l)^(toString k)^")"

let rec caml_format = function
    TYPE -> Format.print_string "Kind.TYPE"
  | ARROW(l,k) ->
      Format.print_string "Kind.ARROW(";
      Misc.formatList " [" "]" ";" caml_format l;
      Format.print_char ','; caml_format k; Format.print_char ')'
